Index: linux-2.6.13-rc6/kernel/ckrm/ckrm_tc.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/ckrm/ckrm_tc.c
+++ linux-2.6.13-rc6/kernel/ckrm/ckrm_tc.c
@@ -100,11 +100,11 @@ struct ckrm_classtype ct_taskclass = {
  * Function is also called with a ckrm_core_grab on the new core, hence
  * it needs to be dropped if no assignment takes place.
  */
 static void
 ckrm_set_taskclass(struct task_struct *tsk, struct ckrm_task_class *newcls,
-		   struct ckrm_task_class *oldcls, enum ckrm_event event)
+		   struct ckrm_task_class *oldcls)
 {
 	int i;
 	struct ckrm_classtype *clstype;
 	struct ckrm_res_ctlr *rcbs;
 	struct ckrm_task_class *curcls;
@@ -181,12 +181,10 @@ ckrm_set_taskclass(struct task_struct *t
 	if (newcls == curcls) {
 		spin_unlock(&tsk->ckrm_tsklock);
 		goto out;
 	}
 
-	CE_NOTIFY(&ct_taskclass, event, newcls, tsk);
-
 	spin_unlock(&tsk->ckrm_tsklock);
 
       rc_handling:
 	clstype = &ct_taskclass;
 	if (clstype->bit_res_ctlrs) {
@@ -230,102 +228,10 @@ static void tc_add_resctrl(struct ckrm_c
 						  core->res_class[resid]);
 	}
 	class_unlock(core);
 }
 
-/**************************************************************************
- *                   Functions called from classification points          *
- **************************************************************************/
-
-#define CE_CLASSIFY_TASK(event, tsk)					\
-do {									\
-	struct ckrm_task_class *newcls = NULL;				\
- 	struct ckrm_task_class *oldcls = tsk->taskclass;		\
-									\
-	CE_CLASSIFY_RET(newcls,&ct_taskclass,event,tsk);		\
-	if (newcls) {							\
-		/* called synchrously. no need to get task struct */	\
-		ckrm_set_taskclass(tsk, newcls, oldcls, event);		\
-	}								\
-} while (0)
-
-
-#define CE_CLASSIFY_TASK_PROTECT(event, tsk)	\
-do {						\
-	ce_protect(&ct_taskclass);		\
-	CE_CLASSIFY_TASK(event,tsk);		\
-	ce_release(&ct_taskclass);              \
-} while (0)
-
-static void cb_taskclass_newtask(void *tsk1)
-{
-	struct task_struct *tsk = (struct task_struct *)tsk1;
-
-	tsk->taskclass = NULL;
-	INIT_LIST_HEAD(&tsk->taskclass_link);
-}
-
-static void cb_taskclass_fork(void *tsk1)
-{
-	struct task_struct *tsk = (struct task_struct *)tsk1;
-	struct ckrm_task_class *cls = NULL;
-
-	pr_debug("%p:%d:%s\n", tsk, tsk->pid, tsk->comm);
-
-	ce_protect(&ct_taskclass);
-	CE_CLASSIFY_RET(cls, &ct_taskclass, CKRM_EVENT_FORK, tsk);
-	if (cls == NULL) {
-		spin_lock(&tsk->parent->ckrm_tsklock);
-		cls = tsk->parent->taskclass;
-		ckrm_core_grab(class_core(cls));
-		spin_unlock(&tsk->parent->ckrm_tsklock);
-	}
-	if (!list_empty(&tsk->taskclass_link))
-		pr_debug("cb_taskclass_fork: BUG in cb_fork.. tsk (%s:%d> already linked\n",
-		       tsk->comm, tsk->pid);
-
-	ckrm_set_taskclass(tsk, cls, NULL, CKRM_EVENT_FORK);
-	ce_release(&ct_taskclass);
-}
-
-static void cb_taskclass_exit(void *tsk1)
-{
-	struct task_struct *tsk = (struct task_struct *)tsk1;
-
-	CE_CLASSIFY_NORET(&ct_taskclass, CKRM_EVENT_EXIT, tsk);
-	ckrm_set_taskclass(tsk, TASK_EXIT_CLASS, NULL, CKRM_EVENT_EXIT);
-}
-
-static void cb_taskclass_exec(void *filename)
-{
-	pr_debug("%p:%d:%s <%s>\n", current, current->pid, current->comm,
-		   (const char *)filename);
-	CE_CLASSIFY_TASK_PROTECT(CKRM_EVENT_EXEC, current);
-}
-
-static void cb_taskclass_uid(void *arg)
-{
-	pr_debug("%p:%d:%s\n", current, current->pid, current->comm);
-	CE_CLASSIFY_TASK_PROTECT(CKRM_EVENT_UID, current);
-}
-
-static void cb_taskclass_gid(void *arg)
-{
-	pr_debug("%p:%d:%s\n", current, current->pid, current->comm);
-	CE_CLASSIFY_TASK_PROTECT(CKRM_EVENT_GID, current);
-}
-
-static struct ckrm_event_spec taskclass_events_callbacks[] = {
-	{CKRM_EVENT_NEWTASK, { cb_taskclass_newtask, NULL}},
-	{CKRM_EVENT_EXEC, { cb_taskclass_exec, NULL }},
-	{CKRM_EVENT_FORK, { cb_taskclass_fork, NULL }},
-	{CKRM_EVENT_EXIT, { cb_taskclass_exit, NULL }},
-	{CKRM_EVENT_UID, { cb_taskclass_uid, NULL }},
-	{CKRM_EVENT_GID, { cb_taskclass_gid, NULL }},
-	{-1, { NULL, NULL }}
-};
-
 /*
  * Asynchronous callback functions   (driven by RCFS)
  *
  *    Async functions force a setting of the task structure
  *    synchronous callbacks are protected against race conditions
@@ -333,141 +239,16 @@ static struct ckrm_event_spec taskclass_
  *    Async calls need to be serialized to ensure they can't
  *    race against each other
  */
 
 static DECLARE_MUTEX(ckrm_async_serializer);	/* serialize all async functions */
-
-/*
- * Go through the task list and reclassify all tasks according to the current
- * classification rules.
- *
- * We have the problem that we can not hold any lock (including the
- * tasklist_lock) while classifying. Two methods possible
- *
- * (a) go through entire pidrange (0..pidmax) and if a task exists at
- *     that pid then reclassify it
- * (b) go several time through task list and build a bitmap for a particular
- *     subrange of pid otherwise the memory requirements ight be too much.
- *
- * We use a hybrid by comparing ratio nr_threads/pidmax
- */
-
-static int ckrm_reclassify_all_tasks(void)
-{
-	extern int pid_max;
-
-	struct task_struct *proc, *thread;
-	int i;
-	int curpidmax = pid_max;
-	int ratio;
-	int use_bitmap;
-
-	/* Check permissions */
-	if ((!capable(CAP_SYS_NICE)) && (!capable(CAP_SYS_RESOURCE))) {
-		return -EPERM;
-	}
-
-	ratio = curpidmax / nr_threads;
-	if (curpidmax <= PID_MAX_DEFAULT) {
-		use_bitmap = 1;
-	} else {
-		use_bitmap = (ratio >= 2);
-	}
-
-	ce_protect(&ct_taskclass);
-
-      retry:
-
-	if (use_bitmap == 0) {
-		/* Go through it in one walk. */
-		read_lock(&tasklist_lock);
-		for (i = 0; i < curpidmax; i++) {
-			if ((thread = find_task_by_pid(i)) == NULL)
-				continue;
-			get_task_struct(thread);
-			read_unlock(&tasklist_lock);
-			CE_CLASSIFY_TASK(CKRM_EVENT_RECLASSIFY, thread);
-			put_task_struct(thread);
-			read_lock(&tasklist_lock);
-		}
-		read_unlock(&tasklist_lock);
-	} else {
-		unsigned long *bitmap;
-		int bitmapsize;
-		int order = 0;
-		int num_loops;
-		int pid, do_next;
-
-		bitmap = (unsigned long *)__get_free_pages(GFP_KERNEL, order);
-		if (bitmap == NULL) {
-			use_bitmap = 0;
-			goto retry;
-		}
-
-		bitmapsize = 8 * (1 << (order + PAGE_SHIFT));
-		num_loops = (curpidmax + bitmapsize - 1) / bitmapsize;
-
-		do_next = 1;
-		for (i = 0; i < num_loops && do_next; i++) {
-			int pid_start = i * bitmapsize;
-			int pid_end = pid_start + bitmapsize;
-			int num_found = 0;
-			int pos;
-
-			memset(bitmap, 0, bitmapsize / 8);	/* start afresh */
-			do_next = 0;
-
-			read_lock(&tasklist_lock);
-			do_each_thread(proc, thread) {
-				pid = thread->pid;
-				if ((pid < pid_start) || (pid >= pid_end)) {
-					if (pid >= pid_end) {
-						do_next = 1;
-					}
-					continue;
-				}
-				pid -= pid_start;
-				set_bit(pid, bitmap);
-				num_found++;
-			}
-			while_each_thread(proc, thread);
-			read_unlock(&tasklist_lock);
-
-			if (num_found == 0)
-				continue;
-
-			pos = 0;
-			for (; num_found--;) {
-				pos = find_next_bit(bitmap, bitmapsize, pos);
-				pid = pos + pid_start;
-
-				read_lock(&tasklist_lock);
-				if ((thread = find_task_by_pid(pid)) != NULL) {
-					get_task_struct(thread);
-					read_unlock(&tasklist_lock);
-					CE_CLASSIFY_TASK(CKRM_EVENT_RECLASSIFY,
-							 thread);
-					put_task_struct(thread);
-				} else {
-					read_unlock(&tasklist_lock);
-				}
-				pos++;
-			}
-		}
-
-	}
-	ce_release(&ct_taskclass);
-	return 0;
-}
-
 /*
  * Reclassify all tasks in the given core class.
  */
 
 static void ckrm_reclassify_class_tasks(struct ckrm_task_class *cls)
 {
-	int ce_regd;
 	struct ckrm_hnode *cnode;
 	struct ckrm_task_class *parcls;
 	int num = 0;
 
 	if (!ckrm_validate_and_grab_core(&cls->core))
@@ -475,53 +256,34 @@ static void ckrm_reclassify_class_tasks(
 
 	down(&ckrm_async_serializer);
 	pr_debug("start %p:%s:%d:%d\n", cls, cls->core.name,
 		 atomic_read(&cls->core.refcnt),
 		 atomic_read(&cls->core.hnode.parent->refcnt));
-	/*
-	 * If no CE registered for this classtype, following will be needed
-	 * repeatedly.
-	 */
-	ce_regd = atomic_read(&class_core(cls)->classtype->ce_regd);
 	cnode = &(class_core(cls)->hnode);
 	parcls = class_type(struct ckrm_task_class, cnode->parent);
 
-      next_task:
-	class_lock(class_core(cls));
-	if (!list_empty(&class_core(cls)->objlist)) {
+	do {
 		struct ckrm_task_class *newcls = NULL;
-		struct task_struct *tsk =
-		    list_entry(class_core(cls)->objlist.next,
-			       struct task_struct, taskclass_link);
+		struct task_struct *tsk = NULL;
+
+		class_lock(class_core(cls));
+		if (list_empty(&class_core(cls)->objlist))
+			break;
+		tsk = list_entry(class_core(cls)->objlist.next,
+				 struct task_struct, taskclass_link);
 
 		get_task_struct(tsk);
 		class_unlock(class_core(cls));
 
-		if (ce_regd) {
-			CE_CLASSIFY_RET(newcls, &ct_taskclass,
-					CKRM_EVENT_RECLASSIFY, tsk);
-			if (cls == newcls) {
-				/*
-				 * Don't allow reclassifying to the same class
-				 * as we are in the process of cleaning up
-				 * this class
-				 */
-
-				/* compensate for CE's grab */
-				ckrm_core_drop(class_core(newcls));
-				newcls = NULL;
-			}
-		}
 		if (newcls == NULL) {
 			newcls = parcls;
 			ckrm_core_grab(class_core(newcls));
 		}
-		ckrm_set_taskclass(tsk, newcls, cls, CKRM_EVENT_RECLASSIFY);
+		ckrm_set_taskclass(tsk, newcls, cls);
 		put_task_struct(tsk);
 		num++;
-		goto next_task;
-	}
+	} while (1);
 	pr_debug("stop  %p:%s:%d:%d   %d\n", cls, cls->core.name,
 		 atomic_read(&cls->core.refcnt),
 		 atomic_read(&cls->core.hnode.parent->refcnt), num);
 	class_unlock(class_core(cls));
 	ckrm_core_drop(class_core(cls));
@@ -559,17 +321,11 @@ int ckrm_forced_reclassify_pid(pid_t pid
 			ckrm_core_drop(class_core(cls));
 		put_task_struct(tsk);
 		return -EPERM;
 	}
 
-	ce_protect(&ct_taskclass);
-	if (cls == NULL)
-		CE_CLASSIFY_TASK(CKRM_EVENT_RECLASSIFY,tsk);
-	else
-		ckrm_set_taskclass(tsk, cls, NULL, CKRM_EVENT_MANUAL);
-
-	ce_release(&ct_taskclass);
+	ckrm_set_taskclass(tsk, cls, NULL);
 	put_task_struct(tsk);
 
 	return 0;
 }
 
@@ -578,20 +334,11 @@ static struct ckrm_core_class *ckrm_allo
 {
 	struct ckrm_task_class *taskcls;
 	taskcls = kmalloc(sizeof(struct ckrm_task_class), GFP_KERNEL);
 	if (taskcls == NULL)
 		return NULL;
-	memset(taskcls, 0, sizeof(struct ckrm_task_class));
-
 	ckrm_init_core_class(&ct_taskclass, class_core(taskcls), parent, name);
-
-	ce_protect(&ct_taskclass);
-	if (ct_taskclass.ce_cb_active && ct_taskclass.ce_callbacks.class_add)
-		(*ct_taskclass.ce_callbacks.class_add) (name, taskcls,
-							ct_taskclass.type_id);
-	ce_release(&ct_taskclass);
-
 	return class_core(taskcls);
 }
 
 static int ckrm_free_task_class(struct ckrm_core_class *core)
 {
@@ -607,43 +354,49 @@ static int ckrm_free_task_class(struct c
 	}
 
 	pr_debug("%p:%s:%d\n", core, core->name, atomic_read(&core->refcnt));
 
 	taskcls = class_type(struct ckrm_task_class, core);
-
-	ce_protect(&ct_taskclass);
-
-	if (ct_taskclass.ce_cb_active && ct_taskclass.ce_callbacks.class_delete)
-		(*ct_taskclass.ce_callbacks.class_delete) (core->name, taskcls,
-							   ct_taskclass.type_id);
 	ckrm_reclassify_class_tasks(taskcls);
-
-	ce_release(&ct_taskclass);
-
 	ckrm_release_core_class(core);
 	return 0;
 }
 
+void ckrm_init_task_struct (struct task_struct *tsk)
+{
+	tsk->ckrm_tsklock = SPIN_LOCK_UNLOCKED;
+	tsk->taskclass = NULL;
+	INIT_LIST_HEAD(&tsk->taskclass_link);
+}
+
+void ckrm_dup_task_struct (struct task_struct *dst,
+			   struct task_struct *src)
+{
+	ckrm_init_task_struct(dst);
+}
+
 void __init ckrm_meta_init_taskclass(void)
 {
 	pr_debug("...... Initializing ClassType<%s> ........\n",
 	       ct_taskclass.name);
+
+
 	/* intialize the default class */
 	ckrm_init_core_class(&ct_taskclass, class_core(&taskclass_dflt_class),
 			     NULL, dflt_taskclass_name);
 
 	/* register classtype and initialize default task class */
 	ckrm_register_classtype(&ct_taskclass);
-	ckrm_register_event_set(taskclass_events_callbacks);
 
 	/*
 	 * note registeration of all resource controllers will be done
 	 * later dynamically as these are specified as modules
 	 */
 
 	/* prepare init_task and then rely on inheritance of properties */
-	ckrm_set_taskclass(&init_task, NULL, NULL, CKRM_EVENT_NEWTASK);
+	ckrm_init_task_struct(&init_task);
+	ckrm_set_taskclass(&init_task, NULL, NULL);
 }
 
 static int tc_show_members(struct ckrm_core_class *core, struct seq_file *seq)
 {
 	struct list_head *lh;
@@ -669,11 +422,11 @@ static int tc_forced_reclassify(struct c
 	down(&ckrm_async_serializer);	/* protect against race with reclassify_class */
 	if (pid < 0) {
 		/* TBD: We could treat this as a process group. */
 		rc = -EINVAL;
 	} else if (pid == 0) {
-		rc = (target == NULL) ? ckrm_reclassify_all_tasks() : -EINVAL;
+		rc = -EINVAL;
 	} else {
 		struct ckrm_task_class *cls = NULL;
 		if (target)
 			cls = class_type(struct ckrm_task_class, target);
 		rc = ckrm_forced_reclassify_pid(pid,cls);
Index: linux-2.6.13-rc6/kernel/exit.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/exit.c
+++ linux-2.6.13-rc6/kernel/exit.c
@@ -25,11 +25,10 @@
 #include <linux/mount.h>
 #include <linux/proc_fs.h>
 #include <linux/mempolicy.h>
 #include <linux/cpuset.h>
 #include <linux/syscalls.h>
-#include <linux/ckrm_events.h>
 #include <linux/signal.h>
 
 #include <asm/uaccess.h>
 #include <asm/unistd.h>
 #include <asm/pgtable.h>
@@ -659,12 +658,10 @@ static void exit_notify(struct task_stru
 {
 	int state;
 	struct task_struct *t;
 	struct list_head ptrace_dead, *_p, *_n;
 
-	ckrm_cb_exit(tsk);
-
 	if (signal_pending(tsk) && !(tsk->signal->flags & SIGNAL_GROUP_EXIT)
 	    && !thread_group_empty(tsk)) {
 		/*
 		 * This occurs when there was a race between our exit
 		 * syscall and a group signal choosing us as the one to
Index: linux-2.6.13-rc6/kernel/fork.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/fork.c
+++ linux-2.6.13-rc6/kernel/fork.c
@@ -39,13 +39,12 @@
 #include <linux/mount.h>
 #include <linux/audit.h>
 #include <linux/profile.h>
 #include <linux/rmap.h>
 #include <linux/acct.h>
-#include <linux/ckrm_events.h>
-#include <linux/ckrm_tsk.h>
 #include <linux/ckrm_tc.h>
+#include <linux/ckrm_tsk.h>
 
 #include <asm/pgtable.h>
 #include <asm/pgalloc.h>
 #include <asm/uaccess.h>
 #include <asm/mmu_context.h>
@@ -175,11 +174,12 @@ static struct task_struct *dup_task_stru
 	*ti = *orig->thread_info;
 	*tsk = *orig;
 	tsk->thread_info = ti;
 	ti->task = tsk;
 
-	ckrm_cb_newtask(tsk);
+	ckrm_dup_task_struct(tsk, orig);
+
 	/* One for us, one for whoever does the "release_task()" (usually parent) */
 	atomic_set(&tsk->usage,2);
 	return tsk;
 }
 
@@ -1227,20 +1227,19 @@ long do_fork(unsigned long clone_flags,
 	}
 
 	if (numtasks_get_ref(&current->taskclass->core, 0) == 0) {
 		return -ENOMEM;
 	}
-	p = copy_process(clone_flags, stack_start, regs, stack_size, parent_tidptr, child_tidptr, pid);
+	p = copy_process(clone_flags, stack_start, regs,
+			 stack_size, parent_tidptr, child_tidptr, pid);
 	/*
 	 * Do this prior waking up the new thread - the thread pointer
 	 * might get invalid after that point, if the thread exits quickly.
 	 */
 	if (!IS_ERR(p)) {
 		struct completion vfork;
 
-		ckrm_cb_fork(p);
-
 		if (clone_flags & CLONE_VFORK) {
 			p->vfork_done = &vfork;
 			init_completion(&vfork);
 		}
 
Index: linux-2.6.13-rc6/init/main.c
===================================================================
--- linux-2.6.13-rc6.orig/init/main.c
+++ linux-2.6.13-rc6/init/main.c
@@ -45,11 +45,11 @@
 #include <linux/efi.h>
 #include <linux/unistd.h>
 #include <linux/rmap.h>
 #include <linux/mempolicy.h>
 #include <linux/key.h>
-#include <linux/ckrm_events.h>
+#include <linux/ckrm.h>
 
 #include <asm/io.h>
 #include <asm/bugs.h>
 #include <asm/setup.h>
 #include <asm/sections.h>
Index: linux-2.6.13-rc6/fs/exec.c
===================================================================
--- linux-2.6.13-rc6.orig/fs/exec.c
+++ linux-2.6.13-rc6/fs/exec.c
@@ -46,11 +46,10 @@
 #include <linux/mount.h>
 #include <linux/security.h>
 #include <linux/syscalls.h>
 #include <linux/rmap.h>
 #include <linux/acct.h>
-#include <linux/ckrm_events.h>
 
 #include <asm/uaccess.h>
 #include <asm/mmu_context.h>
 
 #ifdef CONFIG_KMOD
@@ -1103,11 +1102,10 @@ int search_binary_handler(struct linux_b
 				allow_write_access(bprm->file);
 				if (bprm->file)
 					fput(bprm->file);
 				bprm->file = NULL;
 				current->did_exec = 1;
-				ckrm_cb_exec(bprm->filename);
 				return retval;
 			}
 			read_lock(&binfmt_lock);
 			put_binfmt(fmt);
 			if (retval != -ENOEXEC || bprm->mm == NULL)
Index: linux-2.6.13-rc6/kernel/sys.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/sys.c
+++ linux-2.6.13-rc6/kernel/sys.c
@@ -29,11 +29,10 @@
 #include <linux/tty.h>
 #include <linux/signal.h>
 
 #include <linux/compat.h>
 #include <linux/syscalls.h>
-#include <linux/ckrm_events.h>
 
 #include <asm/uaccess.h>
 #include <asm/io.h>
 #include <asm/unistd.h>
 
@@ -582,11 +581,10 @@ asmlinkage long sys_setregid(gid_t rgid,
 		current->sgid = new_egid;
 	current->fsgid = new_egid;
 	current->egid = new_egid;
 	current->gid = new_rgid;
 	key_fsgid_changed(current);
-	ckrm_cb_gid();
 	return 0;
 }
 
 /*
  * setgid() is implemented like SysV w/ SAVED_IDS 
@@ -622,11 +620,10 @@ asmlinkage long sys_setgid(gid_t gid)
 	}
 	else
 		return -EPERM;
 
 	key_fsgid_changed(current);
-	ckrm_cb_gid();
 	return 0;
 }
   
 static int set_user(uid_t new_ruid, int dumpclear)
 {
@@ -712,13 +709,10 @@ asmlinkage long sys_setreuid(uid_t ruid,
 	    (euid != (uid_t) -1 && euid != old_ruid))
 		current->suid = current->euid;
 	current->fsuid = current->euid;
 
 	key_fsuid_changed(current);
-
-	ckrm_cb_uid();
-
 	return security_task_post_setuid(old_ruid, old_euid, old_suid, LSM_SETID_RE);
 }
 
 
 		
@@ -761,13 +755,10 @@ asmlinkage long sys_setuid(uid_t uid)
 	}
 	current->fsuid = current->euid = uid;
 	current->suid = new_suid;
 
 	key_fsuid_changed(current);
-
-	ckrm_cb_uid();
-
 	return security_task_post_setuid(old_ruid, old_euid, old_suid, LSM_SETID_ID);
 }
 
 
 /*
@@ -811,13 +802,10 @@ asmlinkage long sys_setresuid(uid_t ruid
 	current->fsuid = current->euid;
 	if (suid != (uid_t) -1)
 		current->suid = suid;
 
 	key_fsuid_changed(current);
-
-	ckrm_cb_uid();
-
 	return security_task_post_setuid(old_ruid, old_euid, old_suid, LSM_SETID_RES);
 }
 
 asmlinkage long sys_getresuid(uid_t __user *ruid, uid_t __user *euid, uid_t __user *suid)
 {
@@ -865,11 +853,10 @@ asmlinkage long sys_setresgid(gid_t rgid
 		current->gid = rgid;
 	if (sgid != (gid_t) -1)
 		current->sgid = sgid;
 
 	key_fsgid_changed(current);
-	ckrm_cb_gid();
 	return 0;
 }
 
 asmlinkage long sys_getresgid(gid_t __user *rgid, gid_t __user *egid, gid_t __user *sgid)
 {
Index: linux-2.6.13-rc6/net/ipv4/tcp.c
===================================================================
--- linux-2.6.13-rc6.orig/net/ipv4/tcp.c
+++ linux-2.6.13-rc6/net/ipv4/tcp.c
@@ -261,12 +261,10 @@
 #include <net/icmp.h>
 #include <net/tcp.h>
 #include <net/xfrm.h>
 #include <net/ip.h>
 
-#include <linux/ckrm_events.h>
-
 #include <asm/uaccess.h>
 #include <asm/ioctls.h>
 
 int sysctl_tcp_fin_timeout = TCP_FIN_TIMEOUT;
 
@@ -481,11 +479,10 @@ int tcp_listen_start(struct sock *sk)
 	if (!sk->sk_prot->get_port(sk, inet->num)) {
 		inet->sport = htons(inet->num);
 
 		sk_dst_reset(sk);
 		sk->sk_prot->hash(sk);
-		ckrm_cb_listen_start(sk);
 		return 0;
 	}
 
 	sk->sk_state = TCP_CLOSE;
 	reqsk_queue_destroy(&tp->accept_queue);
@@ -509,12 +506,10 @@ static void tcp_listen_stop (struct sock
 
 	/* make all the listen_opt local to us */
 	lopt = reqsk_queue_yank_listen_sk(&tp->accept_queue);
 	acc_req = reqsk_queue_yank_acceptq(&tp->accept_queue);
 
-	ckrm_cb_listen_stop(sk);
-
 	if (lopt->qlen) {
 		for (i = 0; i < TCP_SYNQ_HSIZE; i++) {
 			while ((req = lopt->syn_table[i]) != NULL) {
 				lopt->syn_table[i] = req->dl_next;
 				lopt->qlen--;
Index: linux-2.6.13-rc6/kernel/ckrm/ckrm_sockc.c
===================================================================
--- linux-2.6.13-rc6.orig/kernel/ckrm/ckrm_sockc.c
+++ linux-2.6.13-rc6/kernel/ckrm/ckrm_sockc.c
@@ -114,11 +114,11 @@ void ckrm_ns_put(struct ckrm_net_struct 
  *
  */
 
 static void
 ckrm_sock_set_class(struct ckrm_net_struct *ns, struct ckrm_sock_class *newcls,
-	       struct ckrm_sock_class *oldcls, enum ckrm_event event)
+	       struct ckrm_sock_class *oldcls)
 {
 	int i;
 	struct ckrm_res_ctlr *rcbs;
 	struct ckrm_classtype *clstype;
 	void *old_res_class, *new_res_class;
@@ -203,19 +203,12 @@ static void cb_sockclass_listen_start(vo
 	ns->ns_dport = inet_sk(sk)->num;
 
 	ns->ns_pid = current->pid;
 	ns->ns_tgid = current->tgid;
 	ns->ns_tsk = current;
-	ce_protect(&ct_sockclass);
-	CE_CLASSIFY_RET(newcls, &ct_sockclass, CKRM_EVENT_LISTEN_START, ns,
-			current);
-	ce_release(&ct_sockclass);
-
-	if (newcls == NULL) {
-		newcls = &ckrm_sockclass_dflt_class;
-		ckrm_core_grab(class_core(newcls));
-	}
+	newcls = &ckrm_sockclass_dflt_class;
+	ckrm_core_grab(class_core(newcls));
 
 	class_lock(class_core(newcls));
 	list_add(&ns->ckrm_link, &class_core(newcls)->objlist);
 	ns->core = newcls;
 	class_unlock(class_core(newcls));
@@ -273,16 +266,10 @@ static void cb_sockclass_listen_stop(voi
 	// Should be the last count and free it
 	ckrm_ns_put(ns);
 	return;
 }
 
-static struct ckrm_event_spec ckrm_sock_events_callbacks[] = {
-	{CKRM_EVENT_LISTEN_START, {cb_sockclass_listen_start, NULL}},
-	{CKRM_EVENT_LISTEN_STOP, {cb_sockclass_listen_stop, NULL}},
-	{-1, {NULL, NULL}}
-};
-
 /**************************************************************************
  *                  Class Object Creation / Destruction
  **************************************************************************/
 
 static struct ckrm_core_class *ckrm_sock_alloc_class(struct ckrm_core_class *parent,
@@ -293,17 +280,10 @@ static struct ckrm_core_class *ckrm_sock
 	if (sockcls == NULL)
 		return NULL;
 	memset(sockcls, 0, sizeof(struct ckrm_sock_class));
 
 	ckrm_init_core_class(&ct_sockclass, class_core(sockcls), parent, name);
-
-	ce_protect(&ct_sockclass);
-	if (ct_sockclass.ce_cb_active && ct_sockclass.ce_callbacks.class_add)
-		(*ct_sockclass.ce_callbacks.class_add) (name, sockcls,
-							ct_sockclass.type_id);
-	ce_release(&ct_sockclass);
-
 	return class_core(sockcls);
 }
 
 static int ckrm_sock_free_class(struct ckrm_core_class *core)
 {
@@ -319,20 +299,11 @@ static int ckrm_sock_free_class(struct c
 		return 0;
 	}
 
 	sockcls = class_type(struct ckrm_sock_class, core);
 
-	ce_protect(&ct_sockclass);
-
-	if (ct_sockclass.ce_cb_active && ct_sockclass.ce_callbacks.class_delete)
-		(*ct_sockclass.ce_callbacks.class_delete) (core->name, sockcls,
-							   ct_sockclass.type_id);
-
 	ckrm_sock_reclassify_class(sockcls);
-
-	ce_release(&ct_sockclass);
-
 	ckrm_release_core_class(core);
 	/* Could just drop the class?  Error message? */
 
 	return 0;
 }
@@ -402,11 +373,11 @@ ckrm_sock_forced_reclassify_ns(struct ck
 	list_del(&ns->ckrm_link);
 	INIT_LIST_HEAD(&ns->ckrm_link);
 	ns->core = NULL;
 	class_unlock(class_core(oldcls));
 
-	ckrm_sock_set_class(ns, newcls, oldcls, CKRM_EVENT_MANUAL);
+	ckrm_sock_set_class(ns, newcls, oldcls);
 	ckrm_ns_put(ns);
 	rc = 0;
       out:
 	release_sock(sk);
 	sock_put(sk);
@@ -529,16 +500,17 @@ static void ckrm_sock_reclassify_class(s
 	ckrm_core_drop(core);
 
 	list_for_each_entry_safe(ns, tns, &local_list, ckrm_link) {
 		ckrm_ns_hold(ns);
 		list_del(&ns->ckrm_link);
-		if (ns->ns_sk) {
-			lock_sock(ns->ns_sk);
-			ckrm_sock_set_class(ns, &ckrm_sockclass_dflt_class, NULL,
-				       CKRM_EVENT_MANUAL);
-			release_sock(ns->ns_sk);
+		if (!ns->ns_sk) {
+			ckrm_ns_put(ns);
+			continue;
 		}
+		lock_sock(ns->ns_sk);
+		ckrm_sock_set_class(ns, &ckrm_sockclass_dflt_class, NULL);
+		release_sock(ns->ns_sk);
 		ckrm_ns_put(ns);
 	}
 	return;
 }
 
@@ -550,11 +522,10 @@ void __init ckrm_meta_init_sockclass(voi
 	ckrm_init_core_class(&ct_sockclass, class_core(&ckrm_sockclass_dflt_class),
 			     NULL, dflt_sockclass_name);
 
 	/* register classtype and initialize default task class */
 	ckrm_register_classtype(&ct_sockclass);
-	ckrm_register_event_set(ckrm_sock_events_callbacks);
 
 	/*
 	 * note registeration of all resource controllers will be done
 	 * later dynamically as these are specified as modules
 	 */
Index: linux-2.6.13-rc6/include/linux/ckrm_tc.h
===================================================================
--- linux-2.6.13-rc6.orig/include/linux/ckrm_tc.h
+++ linux-2.6.13-rc6/include/linux/ckrm_tc.h
@@ -27,20 +27,34 @@
 
 struct ckrm_task_class {
 	struct ckrm_core_class core;
 };
 
+extern void ckrm_init_task_struct (struct task_struct *tsk);
+extern void ckrm_dup_task_struct(struct task_struct *dst,
+				 struct task_struct *src);
+
 /*
  * Index into genmfdesc array, defined in rcfs/dir_modules.c,
  * which has the mfdesc entry that taskclass wants to use.
  */
 #define TC_MF_IDX  0
 
-extern int ckrm_forced_reclassify_pid(int, struct ckrm_task_class *);
+extern int ckrm_forced_reclassify_pid(pid_t, struct ckrm_task_class *);
 
 #else /* CONFIG_CKRM_TYPE_TASKCLASS */
 
-#define ckrm_forced_reclassify_pid(a, b) (0)
+inline int ckrm_forced_reclassify_pid(pid_t pid, void *classp)
+{
+	return 0;
+}
+
+static inline void ckrm_init_task_struct (struct task_struct *tsk)
+{}
+
+static inline void ckrm_dup_task_struct(struct task_struct *dst,
+       					struct task_struct *src)
+{}
 
-#endif
+#endif /* CONFIG_CKRM_TYPE_TASKCLASS */
 
 #endif /* _LINUX_CKRM_TC_H_ */
Index: linux-2.6.13-rc6/include/linux/ckrm.h
===================================================================
--- /dev/null
+++ linux-2.6.13-rc6/include/linux/ckrm.h
@@ -0,0 +1,47 @@
+/*
+ *  ckrm.h - Header file to be used by CKRM
+ *
+ * Copyright (C) Matt Helsley, IBM Corp. 2005
+ *
+ * Provides data structures, macros and kernel API of CKRM for
+ * resource controllers.
+ *
+ * More details at http://ckrm.sf.net
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ */
+
+#ifndef _LINUX_CKRM_H
+#define _LINUX_CKRM_H
+#ifdef CONFIG_CKRM
+extern void ckrm_init(void);
+#include <linux/ckrm_rc.h>
+
+extern void ckrm_init_task_struct (struct task_struct *tsk);
+extern void ckrm_dup_task_struct(struct task_struct *dst,
+				 struct task_struct *src);
+
+extern int ckrm_forced_reclassify_pid(pid_t, struct ckrm_core_class *);
+
+#else
+/* !CONFIG_CKRM */
+
+inline int ckrm_forced_reclassify_pid(pid_t pid, void *classp)
+{
+	return 0;
+}
+
+static inline void ckrm_init_task_struct (struct task_struct *tsk)
+{}
+
+static inline void ckrm_dup_task_struct(struct task_struct *dst,
+       					struct task_struct *src)
+{}
+
+#define ckrm_init() do { } while(0)
+#endif /* CONFIG_CKRM */
+#endif /* _LINUX_CKRM_H */
Index: linux-2.6.13-rc6/include/linux/sched.h
===================================================================
--- linux-2.6.13-rc6.orig/include/linux/sched.h
+++ linux-2.6.13-rc6/include/linux/sched.h
@@ -540,22 +540,10 @@ struct sched_domain {
 	/* try_to_wake_up() stats */
 	unsigned long ttwu_wake_remote;
 	unsigned long ttwu_move_affine;
 	unsigned long ttwu_move_balance;
 #endif
-#ifdef CONFIG_DELAY_ACCT
-	struct task_delay_info delays;
-#endif
-#ifdef CONFIG_CKRM
-	spinlock_t  ckrm_tsklock;
-	void       *ce_data;
-#ifdef CONFIG_CKRM_TYPE_TASKCLASS
-	struct ckrm_task_class *taskclass;
-	struct list_head taskclass_link;
-#endif /* CONFIG_CKRM_TYPE_TASKCLASS */
-#endif /* CONFIG_CKRM */
-
 };
 
 extern void partition_sched_domains(cpumask_t *partition1,
 				    cpumask_t *partition2);
 #ifdef ARCH_HAS_SCHED_DOMAIN
@@ -781,10 +769,21 @@ struct task_struct {
 	struct cpuset *cpuset;
 	nodemask_t mems_allowed;
 	int cpuset_mems_generation;
 #endif
 	atomic_t fs_excl;	/* holding fs exclusive resources */
+
+#ifdef CONFIG_DELAY_ACCT
+	struct task_delay_info delays;
+#endif
+#ifdef CONFIG_CKRM
+	spinlock_t  ckrm_tsklock;
+#ifdef CONFIG_CKRM_TYPE_TASKCLASS
+	struct ckrm_task_class *taskclass;
+	struct list_head taskclass_link;
+#endif /* CONFIG_CKRM_TYPE_TASKCLASS */
+#endif /* CONFIG_CKRM */
 };
 
 static inline pid_t process_group(struct task_struct *tsk)
 {
 	return tsk->signal->pgrp;
